Bug 323527

Summary: KWin crashed
Product: kwin Reporter: gapon <gapon007>
Component: generalAssignee: KWin default assignee <kwin-bugs-null>
Status: RESOLVED FIXED    
Severity: crash CC: am.herrmann, cfeck, hrvoje.senjan, jonathand131, lamarque, lukather35, next-play, rantanplan-web, tobias.hain, vms367
Priority: NOR Keywords: drkonqi
Version: 4.11.0Flags: thomas.luebking: Catalyst+
thomas.luebking: ReviewRequest+
Target Milestone: ---   
Platform: Ubuntu Packages   
OS: Linux   
URL: https://git.reviewboard.kde.org/r/112419/
Latest Commit: Version Fixed In: 4.11.2
Attachments: GL Error clearing patch
glxinfo on HD Mobility Radeon HD 3470 with LIBGL_ALWAYS_INDIRECT=1
Diff of normal glxinfo against LIBGL_ALWAYS_INDIRECT=1
KWin output + support info
Print gl errors after each major init step and some suspicious calls
KWin output with last patch
print errors in initGL
So let's look into glplatform
depend glsl support on direct rendering

Description gapon 2013-08-15 05:42:51 UTC
Application: kwin (4.11.00)
KDE Platform Version: 4.11.00
Qt Version: 4.8.4
Operating System: Linux 3.8.0-27-generic x86_64
Distribution: Ubuntu 13.04

-- Information about the crash:
- What I was doing when the application crashed:

After installing KDE 4.11 from Kubuntu PPA, OpenGL cannot be used in KWin (only XRender works). It used to work without any problem on KDE 4.10.

Thanks.

-- Backtrace:
Application: KWin (kwin), signal: Segmentation fault
Using host libthread_db library "/lib/x86_64-linux-gnu/libthread_db.so.1".
[Current thread is 1 (Thread 0x7f8421a557c0 (LWP 19780))]

Thread 3 (Thread 0x7f8404a09700 (LWP 20385)):
#0  pthread_cond_timedwait@@GLIBC_2.3.2 () at ../nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S:238
#1  0x00007f841b6800a7 in wait (time=30000, this=0x844340) at thread/qwaitcondition_unix.cpp:84
#2  QWaitCondition::wait (this=<optimized out>, mutex=0x8442e8, time=30000) at thread/qwaitcondition_unix.cpp:158
#3  0x00007f841b67364f in QThreadPoolThread::run (this=0x843890) at concurrent/qthreadpool.cpp:141
#4  0x00007f841b67fbec in QThreadPrivate::start (arg=0x843890) at thread/qthread_unix.cpp:338
#5  0x00007f8418f54f8e in start_thread (arg=0x7f8404a09700) at pthread_create.c:311
#6  0x00007f842134ae1d in clone () at ../sysdeps/unix/sysv/linux/x86_64/clone.S:113

Thread 2 (Thread 0x7f83fef29700 (LWP 20387)):
#0  pthread_cond_wait@@GLIBC_2.3.2 () at ../nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S:185
#1  0x00007f8420540b27 in ?? () from /usr/lib/x86_64-linux-gnu/libQtScript.so.4
#2  0x00007f8420540b59 in ?? () from /usr/lib/x86_64-linux-gnu/libQtScript.so.4
#3  0x00007f8418f54f8e in start_thread (arg=0x7f83fef29700) at pthread_create.c:311
#4  0x00007f842134ae1d in clone () at ../sysdeps/unix/sysv/linux/x86_64/clone.S:113

Thread 1 (Thread 0x7f8421a557c0 (LWP 19780)):
[KCrash Handler]
#6  value (this=0x0) at ../../kwin/libkwineffects/kwinxrenderutils.h:107
#7  operator xcb_render_picture_t (this=0x9707c0) at ../../kwin/libkwineffects/kwinxrenderutils.h:119
#8  KWin::SceneXRenderShadow::prepareBackend (this=0xc168e0) at ../../kwin/scene_xrender.cpp:1119
#9  0x00007f84216a24fc in KWin::Shadow::init (this=this@entry=0xc168e0, data=...) at ../../kwin/shadow.cpp:109
#10 0x00007f84216a26f5 in KWin::Shadow::createShadow (toplevel=toplevel@entry=0x9290d0) at ../../kwin/shadow.cpp:61
#11 0x00007f84216df728 in KWin::Toplevel::getShadow (this=0x9290d0) at ../../kwin/toplevel.cpp:364
#12 0x00007f842169eeaa in KWin::Toplevel::propertyNotifyEvent (this=this@entry=0x9290d0, e=e@entry=0x7fff1cc3f6c0) at ../../kwin/events.cpp:1546
#13 0x00007f842169eee9 in KWin::Client::propertyNotifyEvent (this=0x9290d0, e=0x7fff1cc3f6c0) at ../../kwin/events.cpp:695
#14 0x00007f842169e500 in KWin::Client::windowEvent (this=0x9290d0, e=e@entry=0x7fff1cc3f6c0) at ../../kwin/events.cpp:463
#15 0x00007f842169f2d3 in KWin::Workspace::workspaceEvent (this=0x843bf0, e=e@entry=0x7fff1cc3f6c0) at ../../kwin/events.cpp:155
#16 0x00007f8421694db8 in KWin::Application::x11EventFilter (this=0x7fff1cc3fc20, e=0x7fff1cc3f6c0) at ../../kwin/main.cpp:414
#17 0x00007f841ab8e05c in qt_x11EventFilter (ev=0x7fff1cc3f6c0) at kernel/qapplication_x11.cpp:441
#18 qt_x11EventFilter (ev=0x7fff1cc3f6c0) at kernel/qapplication_x11.cpp:429
#19 0x00007f841ab9c100 in QApplication::x11ProcessEvent (this=0x7fff1cc3fc20, event=event@entry=0x7fff1cc3f6c0) at kernel/qapplication_x11.cpp:3458
#20 0x00007f841abc8ac9 in QEventDispatcherX11::processEvents (this=0x621ad0, flags=...) at kernel/qeventdispatcher_x11.cpp:132
#21 0x00007f841b77b38f in QEventLoop::processEvents (this=this@entry=0x7fff1cc3f930, flags=...) at kernel/qeventloop.cpp:149
#22 0x00007f841b77b618 in QEventLoop::exec (this=this@entry=0x7fff1cc3f930, flags=...) at kernel/qeventloop.cpp:204
#23 0x00007f841b780cf6 in QCoreApplication::exec () at kernel/qcoreapplication.cpp:1218
#24 0x00007f841ab20ffc in QApplication::exec () at kernel/qapplication.cpp:3828
#25 0x00007f8421694703 in kdemain (argc=3, argv=0x7fff1cc3fd68) at ../../kwin/main.cpp:589
#26 0x00007f8421272ea5 in __libc_start_main (main=0x4006d0 <main(int, char**)>, argc=3, ubp_av=0x7fff1cc3fd68, init=<optimized out>, fini=<optimized out>, rtld_fini=<optimized out>, stack_end=0x7fff1cc3fd58) at libc-start.c:260
#27 0x0000000000400701 in _start ()

Reported using DrKonqi
Comment 1 Thomas Lübking 2013-08-15 07:58:22 UTC
This
#6  value (this=0x0) at ../../kwin/libkwineffects/kwinxrenderutils.h:107
suggests the d pointer of XRenderPicture ::isNull right after it was created the line before.

Do you get these crashes (this is from the XRender compositor) more often? Do they all have similar backtraces (esp. the above line)?

Also what do you mean by "OpenGL cannot be used"?
-> Other crashes? This crash?

- What's the output of "glxinfo"?
- What ppa did you use exactly?
- Did you log out / in after the installation?
Comment 2 gapon 2013-08-15 08:26:58 UTC
Thanks a lot for your fast feedback! I will try to do as much as I can to help you since KWin is currently unusable for me (and it is not easily possible to downgrade to KDE 4.10, too many package conflicts...).

What I did exactly:
- today, I installed KDE 4.11 - I am on Kubuntu, using these official Kubuntu PPAs:
deb http://ppa.launchpad.net/kubuntu-ppa/ppa/ubuntu raring main
deb http://ppa.launchpad.net/kubuntu-ppa/backports/ubuntu raring main
- i did logget out and logged in
- everything seemed to be ok, however, I have noticed that the Konsole background is not transparent...
- OK, I tried to restart my laptop, just to be sure
- the problem was still there, so I have verified that I am using direct rendering [1]. I opened KWin settings - as a composition type, there was OpenGL 2.0 selected - I tried to change it to XRender and back to OpenGL but no success, OpenGL cannot be used (dialog saying that appeared) - see relevant lines from my .xsession-errors file [2] (these lines were added once I selected OpenGL and clicked OK button [I maybe put here a few lines more, not sure where it ends])
- I tried to use XRender but it is soooo sloooow (Chrome with Gmail or Google maps was not possible to use) that currently I have to use OpenBox instead of KWin - works fine

Output of glxinfo is [3].

Just to be sure - I was using KWin without any problems from the beginning (I bought my laptop 3 years ago) with OpenGL 2.0. Now, with KWin 4.11, it stopped working.

Thanks!
[1]
glxinfo | grep rendering
direct rendering: Yes
[2]
OpenGL vendor string:                   ATI Technologies Inc.
OpenGL renderer string:                 AMD Radeon HD 6570M/5700 Series
OpenGL version string:                  2.1 (4.2.12002 Compatibility Profile Context 8.723.1)
OpenGL shading language version string: 
Driver:                                 Catalyst
Driver version:                         2.1
GPU class:                              NI
OpenGL version:                         2.1
GLSL version:                           0.0
X server version:                       1.13.3
Linux kernel version:                   3.8
Direct rendering:                       no
Requires strict binding:                yes
GLSL shaders:                           yes
Texture NPOT support:                   yes
Virtual Machine:                        no
kwin(20435) KWin::checkGLError: GL error ( Init ):  "GL_INVALID_ENUM" 
kwin(20435): OpenGL 1 compositing setup failed 
QObject::connect: Cannot connect (null)::resetCompositing() to KWin::Compositor::restart()
kwin(20435): Failed to initialize compositing, compositing disabled 
kwin(20435): Consult http://techbase.kde.org/Projects/KWin/4.0-release-notes#Setting_up 
Could not resolve property : linearGradient3899
Could not resolve property : linearGradient3899
Could not resolve property : linearGradient3899
Could not resolve property : linearGradient3899
Could not resolve property : linearGradient3899
link XMLID_5_ hasn't been detected!
link XMLID_34_ hasn't been detected!
link XMLID_34_ hasn't been detected!
link XMLID_36_ hasn't been detected!
Could not resolve property : radialGradient3709
Could not resolve property : radialGradient3709
Could not resolve property : radialGradient6084
Could not resolve property : radialGradient3756
X Error: BadWindow (invalid Window parameter) 3
  Major opcode: 20 (X_GetProperty)
  Resource id:  0x7a00288
kwin(20435) KWin::EffectsHandlerImpl::loadEffect: EffectsHandler::loadEffect : Effect  "kwin4_effect_flipswitch"  is not supported 
kwin(20435) KWin::EffectsHandlerImpl::loadEffect: EffectsHandler::loadEffect : Effect  "kwin4_effect_wobblywindows"  is not supported 
kwin(20435) KWin::EffectsHandlerImpl::loadEffect: EffectsHandler::loadEffect : Effect  "kwin4_effect_blur"  is not supported 
kwin(20435) KWin::EffectsHandlerImpl::loadEffect: EffectsHandler::loadEffect : Effect  "kwin4_effect_cube"  is not supported 
kwin(20435) KWin::EffectsHandlerImpl::loadEffect: EffectsHandler::loadEffect : Effect  "kwin4_effect_coverswitch"  is not supported 
kwin(20435) KWin::EffectsHandlerImpl::loadEffect: EffectsHandler::loadEffect : Effect  "kwin4_effect_startupfeedback"  is not supported 
[3]
name of display: :0
display: :0  screen: 0
direct rendering: Yes
server glx vendor string: ATI
server glx version string: 1.4
server glx extensions:
    GLX_ARB_multisample, GLX_EXT_import_context, GLX_EXT_texture_from_pixmap, 
    GLX_EXT_visual_info, GLX_EXT_visual_rating, GLX_OML_swap_method, 
    GLX_SGI_make_current_read, GLX_SGI_swap_control, GLX_SGIS_multisample, 
    GLX_SGIX_fbconfig, GLX_SGIX_pbuffer, GLX_SGIX_visual_select_group
client glx vendor string: ATI
client glx version string: 1.4
client glx extensions:
    GLX_ARB_create_context, GLX_ARB_create_context_profile, 
    GLX_ARB_get_proc_address, GLX_ARB_multisample, GLX_EXT_import_context, 
    GLX_EXT_swap_control, GLX_EXT_visual_info, GLX_EXT_visual_rating, 
    GLX_MESA_allocate_memory, GLX_MESA_copy_sub_buffer, GLX_MESA_swap_control, 
    GLX_MESA_swap_frame_usage, GLX_NV_swap_group, GLX_OML_swap_method, 
    GLX_SGI_make_current_read, GLX_SGI_swap_control, GLX_SGI_video_sync, 
    GLX_SGIS_multisample, GLX_SGIX_fbconfig, GLX_SGIX_pbuffer, 
    GLX_SGIX_swap_barrier, GLX_SGIX_swap_group, GLX_SGIX_visual_select_group, 
    GLX_EXT_texture_from_pixmap, GLX_EXT_framebuffer_sRGB, 
    GLX_ARB_fbconfig_float, GLX_AMD_gpu_association
GLX version: 1.4
GLX extensions:
    GLX_ARB_create_context, GLX_ARB_create_context_profile, 
    GLX_ARB_get_proc_address, GLX_ARB_multisample, GLX_EXT_import_context, 
    GLX_EXT_swap_control, GLX_EXT_visual_info, GLX_EXT_visual_rating, 
    GLX_MESA_swap_control, GLX_NV_swap_group, GLX_OML_swap_method, 
    GLX_SGI_make_current_read, GLX_SGI_swap_control, GLX_SGI_video_sync, 
    GLX_SGIS_multisample, GLX_SGIX_fbconfig, GLX_SGIX_pbuffer, 
    GLX_SGIX_swap_barrier, GLX_SGIX_swap_group, GLX_SGIX_visual_select_group, 
    GLX_EXT_texture_from_pixmap
OpenGL vendor string: Advanced Micro Devices, Inc.
OpenGL renderer string: AMD Radeon HD 6570M/5700 Series
OpenGL version string: 4.2.12002 Compatibility Profile Context 8.723.1
OpenGL shading language version string: 4.20
OpenGL extensions:
    GL_AMDX_debug_output, GL_AMDX_vertex_shader_tessellator, 
    GL_AMD_conservative_depth, GL_AMD_debug_output, 
    GL_AMD_depth_clamp_separate, GL_AMD_draw_buffers_blend, 
    GL_AMD_multi_draw_indirect, GL_AMD_name_gen_delete, 
    GL_AMD_performance_monitor, GL_AMD_pinned_memory, 
    GL_AMD_query_buffer_object, GL_AMD_sample_positions, 
    GL_AMD_seamless_cubemap_per_texture, GL_AMD_shader_stencil_export, 
    GL_AMD_shader_trace, GL_AMD_texture_cube_map_array, 
    GL_AMD_texture_texture4, GL_AMD_transform_feedback3_lines_triangles, 
    GL_AMD_vertex_shader_layer, GL_AMD_vertex_shader_tessellator, 
    GL_AMD_vertex_shader_viewport_index, GL_ARB_ES2_compatibility, 
    GL_ARB_base_instance, GL_ARB_blend_func_extended, 
    GL_ARB_color_buffer_float, GL_ARB_compressed_texture_pixel_storage, 
    GL_ARB_conservative_depth, GL_ARB_copy_buffer, GL_ARB_depth_buffer_float, 
    GL_ARB_depth_clamp, GL_ARB_depth_texture, GL_ARB_draw_buffers, 
    GL_ARB_draw_buffers_blend, GL_ARB_draw_elements_base_vertex, 
    GL_ARB_draw_indirect, GL_ARB_draw_instanced, 
    GL_ARB_explicit_attrib_location, GL_ARB_fragment_coord_conventions, 
    GL_ARB_fragment_program, GL_ARB_fragment_program_shadow, 
    GL_ARB_fragment_shader, GL_ARB_framebuffer_object, 
    GL_ARB_framebuffer_sRGB, GL_ARB_geometry_shader4, 
    GL_ARB_get_program_binary, GL_ARB_gpu_shader5, GL_ARB_gpu_shader_fp64, 
    GL_ARB_half_float_pixel, GL_ARB_half_float_vertex, GL_ARB_imaging, 
    GL_ARB_instanced_arrays, GL_ARB_internalformat_query, 
    GL_ARB_map_buffer_alignment, GL_ARB_map_buffer_range, GL_ARB_multisample, 
    GL_ARB_multitexture, GL_ARB_occlusion_query, GL_ARB_occlusion_query2, 
    GL_ARB_pixel_buffer_object, GL_ARB_point_parameters, GL_ARB_point_sprite, 
    GL_ARB_provoking_vertex, GL_ARB_sample_shading, GL_ARB_sampler_objects, 
    GL_ARB_seamless_cube_map, GL_ARB_separate_shader_objects, 
    GL_ARB_shader_atomic_counters, GL_ARB_shader_bit_encoding, 
    GL_ARB_shader_image_load_store, GL_ARB_shader_objects, 
    GL_ARB_shader_precision, GL_ARB_shader_stencil_export, 
    GL_ARB_shader_subroutine, GL_ARB_shader_texture_lod, 
    GL_ARB_shading_language_100, GL_ARB_shading_language_420pack, 
    GL_ARB_shading_language_packing, GL_ARB_shadow, GL_ARB_shadow_ambient, 
    GL_ARB_sync, GL_ARB_tessellation_shader, GL_ARB_texture_border_clamp, 
    GL_ARB_texture_buffer_object, GL_ARB_texture_buffer_object_rgb32, 
    GL_ARB_texture_buffer_range, GL_ARB_texture_compression, 
    GL_ARB_texture_compression_bptc, GL_ARB_texture_compression_rgtc, 
    GL_ARB_texture_cube_map, GL_ARB_texture_cube_map_array, 
    GL_ARB_texture_env_add, GL_ARB_texture_env_combine, 
    GL_ARB_texture_env_crossbar, GL_ARB_texture_env_dot3, 
    GL_ARB_texture_float, GL_ARB_texture_gather, 
    GL_ARB_texture_mirrored_repeat, GL_ARB_texture_multisample, 
    GL_ARB_texture_non_power_of_two, GL_ARB_texture_query_lod, 
    GL_ARB_texture_rectangle, GL_ARB_texture_rg, GL_ARB_texture_rgb10_a2ui, 
    GL_ARB_texture_snorm, GL_ARB_texture_storage, 
    GL_ARB_texture_storage_multisample, GL_ARB_timer_query, 
    GL_ARB_transform_feedback2, GL_ARB_transform_feedback3, 
    GL_ARB_transform_feedback_instanced, GL_ARB_transpose_matrix, 
    GL_ARB_uniform_buffer_object, GL_ARB_vertex_array_bgra, 
    GL_ARB_vertex_array_object, GL_ARB_vertex_attrib_64bit, 
    GL_ARB_vertex_buffer_object, GL_ARB_vertex_program, GL_ARB_vertex_shader, 
    GL_ARB_vertex_type_2_10_10_10_rev, GL_ARB_viewport_array, 
    GL_ARB_window_pos, GL_ATI_draw_buffers, GL_ATI_envmap_bumpmap, 
    GL_ATI_fragment_shader, GL_ATI_meminfo, GL_ATI_separate_stencil, 
    GL_ATI_texture_compression_3dc, GL_ATI_texture_env_combine3, 
    GL_ATI_texture_float, GL_ATI_texture_mirror_once, GL_EXT_abgr, 
    GL_EXT_bgra, GL_EXT_bindable_uniform, GL_EXT_blend_color, 
    GL_EXT_blend_equation_separate, GL_EXT_blend_func_separate, 
    GL_EXT_blend_minmax, GL_EXT_blend_subtract, GL_EXT_compiled_vertex_array, 
    GL_EXT_copy_buffer, GL_EXT_copy_texture, GL_EXT_direct_state_access, 
    GL_EXT_draw_buffers2, GL_EXT_draw_instanced, GL_EXT_draw_range_elements, 
    GL_EXT_fog_coord, GL_EXT_framebuffer_blit, GL_EXT_framebuffer_multisample, 
    GL_EXT_framebuffer_object, GL_EXT_framebuffer_sRGB, 
    GL_EXT_geometry_shader4, GL_EXT_gpu_program_parameters, 
    GL_EXT_gpu_shader4, GL_EXT_histogram, GL_EXT_multi_draw_arrays, 
    GL_EXT_packed_depth_stencil, GL_EXT_packed_float, GL_EXT_packed_pixels, 
    GL_EXT_pixel_buffer_object, GL_EXT_point_parameters, 
    GL_EXT_provoking_vertex, GL_EXT_rescale_normal, GL_EXT_secondary_color, 
    GL_EXT_separate_specular_color, GL_EXT_shader_image_load_store, 
    GL_EXT_shadow_funcs, GL_EXT_stencil_wrap, GL_EXT_subtexture, 
    GL_EXT_texgen_reflection, GL_EXT_texture3D, GL_EXT_texture_array, 
    GL_EXT_texture_buffer_object, GL_EXT_texture_compression_bptc, 
    GL_EXT_texture_compression_latc, GL_EXT_texture_compression_rgtc, 
    GL_EXT_texture_compression_s3tc, GL_EXT_texture_cube_map, 
    GL_EXT_texture_edge_clamp, GL_EXT_texture_env_add, 
    GL_EXT_texture_env_combine, GL_EXT_texture_env_dot3, 
    GL_EXT_texture_filter_anisotropic, GL_EXT_texture_integer, 
    GL_EXT_texture_lod, GL_EXT_texture_lod_bias, GL_EXT_texture_mirror_clamp, 
    GL_EXT_texture_object, GL_EXT_texture_rectangle, GL_EXT_texture_sRGB, 
    GL_EXT_texture_sRGB_decode, GL_EXT_texture_shared_exponent, 
    GL_EXT_texture_snorm, GL_EXT_texture_storage, GL_EXT_texture_swizzle, 
    GL_EXT_timer_query, GL_EXT_transform_feedback, GL_EXT_vertex_array, 
    GL_EXT_vertex_array_bgra, GL_EXT_vertex_attrib_64bit, 
    GL_IBM_texture_mirrored_repeat, GL_KTX_buffer_region, GL_NV_blend_square, 
    GL_NV_conditional_render, GL_NV_copy_depth_to_color, GL_NV_copy_image, 
    GL_NV_explicit_multisample, GL_NV_float_buffer, GL_NV_half_float, 
    GL_NV_primitive_restart, GL_NV_texgen_reflection, GL_NV_texture_barrier, 
    GL_SGIS_generate_mipmap, GL_SGIS_texture_edge_clamp, GL_SGIS_texture_lod, 
    GL_SUN_multi_draw_arrays, GL_WIN_swap_hint

81 GLX Visuals
    visual  x   bf lv rg d st  colorbuffer  sr ax dp st accumbuffer  ms  cav
  id dep cl sp  sz l  ci b ro  r  g  b  a F gb bf th cl  r  g  b  a ns b eat
----------------------------------------------------------------------------
0x023 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x024 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x025 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x026 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x027 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 None
0x028 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 None
0x029 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 None
0x02a 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 None
0x02b 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x02c 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x02d 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x02e 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x02f 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  2 1 None
0x030 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  2 1 None
0x031 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  2 1 None
0x032 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  2 1 None
0x033 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x034 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x035 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x036 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x037 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  4 1 None
0x038 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  4 1 None
0x039 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 None
0x03a 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 None
0x03b 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x03c 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x03d 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x03e 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x03f 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  6 1 None
0x040 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  6 1 None
0x041 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  6 1 None
0x042 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  6 1 None
0x043 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x044 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x045 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x046 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x047 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  8 1 None
0x048 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  8 1 None
0x049 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  8 1 None
0x04a 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  8 1 None
0x04b 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x04c 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x04d 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x04e 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x04f 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 None
0x050 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 None
0x051 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 None
0x052 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 None
0x053 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x054 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x055 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x056 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x057 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  2 1 None
0x058 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  2 1 None
0x059 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  2 1 None
0x05a 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  2 1 None
0x05b 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x05c 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x05d 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x05e 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x05f 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  4 1 None
0x060 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  4 1 None
0x061 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 None
0x062 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 None
0x063 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x064 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x065 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x066 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x067 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  6 1 None
0x068 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  6 1 None
0x069 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  6 1 None
0x06a 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  6 1 None
0x06b 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x06c 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x06d 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x06e 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x06f 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  8 1 None
0x070 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  8 1 None
0x071 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  8 1 None
0x072 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  8 1 None
0x0b8 32 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 Ncon

91 GLXFBConfigs:
    visual  x   bf lv rg d st  colorbuffer  sr ax dp st accumbuffer  ms  cav
  id dep cl sp  sz l  ci b ro  r  g  b  a F gb bf th cl  r  g  b  a ns b eat
----------------------------------------------------------------------------
0x023 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x024 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x025 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x026 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x027 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 None
0x028 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 None
0x029 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 None
0x02a 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 None
0x02b 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x02c 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x02d 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x02e 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x02f 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  2 1 None
0x030 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  2 1 None
0x031 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  2 1 None
0x032 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  2 1 None
0x033 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x034 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x035 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x036 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x037 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  4 1 None
0x038 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  4 1 None
0x039 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 None
0x03a 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 None
0x03b 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x03c 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x03d 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x03e 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x03f 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  6 1 None
0x040 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  6 1 None
0x041 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  6 1 None
0x042 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  6 1 None
0x043 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x044 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x045 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x046 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x047 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  8 1 None
0x048 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  8 1 None
0x049 24 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  8 1 None
0x04a 24 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  8 1 None
0x04b 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x04c 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x04d 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x04e 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x04f 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 None
0x050 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 None
0x051 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 None
0x052 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 None
0x053 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x054 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x055 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x056 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x057 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  2 1 None
0x058 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  2 1 None
0x059 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  2 1 None
0x05a 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  2 1 None
0x05b 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x05c 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x05d 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x05e 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x05f 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  4 1 None
0x060 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  4 1 None
0x061 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 None
0x062 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 None
0x063 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x064 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x065 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x066 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x067 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  6 1 None
0x068 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  6 1 None
0x069 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  6 1 None
0x06a 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  6 1 None
0x06b 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x06c 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8 16 16 16 16  0 0 None
0x06d 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x06e 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0 16 16 16 16  0 0 None
0x06f 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  8 1 None
0x070 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  8 1 None
0x071 24 dc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  8 1 None
0x072 24 dc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  8 1 None
0x0b8 32 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  0  0  0  0  0  4 1 Ncon
0x0b8 32 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  0  0  0  0  0  0 0 Ncon
0x0b8 32 tc  0  32  0 r  y .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 Ncon
0x0b8 32 tc  0  32  0 r  . .   8  8  8  8 .  .  0 24  8  0  0  0  0  0 0 Ncon
0x0b8 32 tc  0  32  0 r  . .   8  8  8  8 .  .  0  0  0  0  0  0  0  0 0 Ncon
0x0b8  0 tc  0 128  0    y .  32 32 32 32 .  .  0 24  0  0  0  0  0  0 0 None
0x0b8  0 tc  0 128  0    . .  32 32 32 32 .  .  0 24  0  0  0  0  0  0 0 None
0x0b8  0 tc  0  64  0    y .  16 16 16 16 .  .  0 24  0  0  0  0  0  0 0 None
0x0b8  0 tc  0  64  0    . .  16 16 16 16 .  .  0 24  0  0  0  0  0  0 0 None
0x0b8  0 tc  0  32  0    y .  11 11 10  0 .  .  0 24  0  0  0  0  0  0 0 None
0x0b8  0 tc  0  32  0    . .  11 11 10  0 .  .  0 24  0  0  0  0  0  0 0 None
Comment 3 gapon 2013-08-15 08:30:54 UTC
One more note - I was not precise - I am not sure which exact version of OpenGL I was using, but it was OpenGL (XRender is very slow for me and the "OpenGL 2.0" was selected when I opened the Kwin settings dialog).

Thanks.
Comment 4 Thomas Lübking 2013-08-15 09:28:25 UTC
Try running (kwin does not use direct rendering on that catalyst version for random crashes occured, but the version number matching might be flawed on the legacy driver - there's however been no change in that regard)

export KWIN_DIRECT_GL=1
kwin --replace &

to setup GL compositing

It atm. fails in even OpenGL 1 (no shaders) setup for an  GL_INVALID_ENUM error which would be caused a trivial scene setup (does glxgears work?)
Comment 5 gapon 2013-08-15 09:53:30 UTC
(In reply to comment #4)
> export KWIN_DIRECT_GL=1
> kwin --replace &

That did the trick! Thanks a lot!

> It atm. fails in even OpenGL 1 (no shaders) setup for an  GL_INVALID_ENUM
> error which would be caused a trivial scene setup (does glxgears work?)

BTW glxgears works for me [1].

Thanks a lot for your help, really! Much appreciated!
[1]
gapon@cattie ~ $ glxgears                                                                                                                                                                                                     
8341 frames in 5.0 seconds = 1668.038 FPS                                                                                                                                                                                                    
8813 frames in 5.0 seconds = 1762.535 FPS                                                                                                                                                                                                    
9271 frames in 5.0 seconds = 1854.047 FPS
Comment 6 Thomas Lübking 2013-08-15 17:46:00 UTC
*** Bug 323553 has been marked as a duplicate of this bug. ***
Comment 7 Jonathan D. 2013-08-21 07:37:38 UTC
I have the same problem than Lamarque (compositing not enabled, cf. #323553) with the fglrx driver provided by the Ubuntu repositories for the 12.04 LTS version :
$ dpkg -l|grep fglrx                                                                                                                                                                                                                                      
ii  fglrx                                         2:8.960-0ubuntu1.1                                  Video driver for the AMD graphics accelerators
ii  fglrx-amdcccle                                2:8.960-0ubuntu1.1                                  Catalyst Control Center for the AMD graphics accelerators
$ aticonfig --get-pcs-key=LDC,ReleaseVersion
String: 8.723.1-100408a-098580C-ATI

Also, doing the following commands as pointed by Lamarque enables compositing (https://bugs.kde.org/show_bug.cgi?id=323553#c0):
export KWIN_DIRECT_GL=1
export KWIN_COMPOSE=O2
kwin --replace &
Comment 8 Thomas Lübking 2013-08-21 14:55:09 UTC
*** Bug 323726 has been marked as a duplicate of this bug. ***
Comment 9 Thomas Lübking 2013-08-22 16:30:47 UTC
*** Bug 323898 has been marked as a duplicate of this bug. ***
Comment 10 Thomas Lübking 2013-08-23 17:39:08 UTC
*** Bug 323927 has been marked as a duplicate of this bug. ***
Comment 11 Thomas Lübking 2013-08-27 07:12:52 UTC
Created attachment 81958 [details]
GL Error clearing patch

Can you try the attached patch?

@Martin
I guess attempting to set the swapInterval on an indirect context might cause the invalid enum?
Comment 12 Martin Flöser 2013-08-28 05:27:45 UTC
> I guess attempting to set the swapInterval on an indirect context might
> cause the invalid enum?
just checked the spec [1] - it shouldn't. It's only allowed to generate 
BadValue or BadWindow errors. But it's OpenGL - who knows what the drivers 
implemented...

[1] https://www.opengl.org/registry/specs/EXT/swap_control.txt
Comment 13 Thomas Lübking 2013-08-28 23:40:22 UTC
Ok, another try: can anyone encoutering the bug please check

export LIBGL_ALWAYS_INDIRECT=1
glxinfo
glxgears

(the interesting question is whether indirect contexts work at all on the driver - or if either of glxinfo or glxgears crashes/aborts/breaks otherwise with LIBGL_ALWAYS_INDIRECT=1)
Comment 14 Tobias Hain 2013-08-29 10:59:58 UTC
Created attachment 82008 [details]
glxinfo on HD Mobility Radeon HD 3470 with LIBGL_ALWAYS_INDIRECT=1

Attached the output of glxinfo with indirect rendering.

One reason why some people like me still use the proprietory driver: It has proper GPU power management, which is really desirable on notebooks. GPU power management with voltage and significant less power consumption lands in 3.11 kernel and is not available in mainstream distributions:
http://www.phoronix.com/scan.php?page=news_item&px=MTM5NjE
http://www.phoronix.com/scan.php?page=article&item=amd_radeon_dpm&num=1
Comment 15 Thomas Lübking 2013-08-29 15:17:34 UTC
(In reply to comment #14)
> Created attachment 82008 [details]
> glxinfo on HD Mobility Radeon HD 3470 with LIBGL_ALWAYS_INDIRECT=1

Thanks, does glxgears work on indirect rendering?
(Or anything else on GL at hand)
Comment 16 Tobias Hain 2013-08-29 16:31:19 UTC
yes, glxgears works fine in indirect mode. Sorry forgot to mention. Will try Moore sophisticated GL apps later.
Comment 17 Tobias Hain 2013-08-29 18:19:34 UTC
Some more specific information. glxgears works fine, although it prints this error when exiting:
7720 frames in 5.0 seconds = 1542.371 FPS
XIO:  fatal IO error 11 (Resource temporarily unavailable) on X server ":0"
      after 38619 requests (40 known processed) with 0 events remaining.

Tried /usr/bin/marble as well with indirect rendering environment variable and it seems fine.
Comment 18 Martin Flöser 2013-08-29 18:32:21 UTC
> Some more specific information. glxgears works fine, although it prints this
> error when exiting:
> 7720 frames in 5.0 seconds = 1542.371 FPS
> XIO:  fatal IO error 11 (Resource temporarily unavailable) on X server ":0"
>       after 38619 requests (40 known processed) with 0 events remaining.
that's normal
> 
> Tried /usr/bin/marble as well with indirect rendering environment variable
> and it seems fine.
I didn't know marble does Opengl
Comment 19 Hrvoje Senjan 2013-08-30 22:05:27 UTC
So, this is at least old as: https://bugs.kde.org/show_bug.cgi?id=321760#c26 ?  (sorry if mixing things up)
I can try the patch from comment 11 if needed. (Need to prepare myself for switching back to catalyst :-)
Comment 20 Hrvoje Senjan 2013-08-30 23:31:36 UTC
Created attachment 82045 [details]
Diff of normal glxinfo against LIBGL_ALWAYS_INDIRECT=1
Comment 21 Hrvoje Senjan 2013-08-31 00:07:01 UTC
Created attachment 82046 [details]
KWin output + support info

Yes, the patch resolved the problem here :-)
Comment 22 Thomas Lübking 2013-08-31 00:29:24 UTC
Created attachment 82047 [details]
Print gl errors after each major init step and some suspicious calls

(In reply to comment #19)
> So, this is at least old as: https://bugs.kde.org/show_bug.cgi?id=321760#c26

That (original) bug is fixed/worked around, but indeed - the comment contains the same failure, which you figured to be unfortunately not even avoided bypasseing GLX_ARB_create_context (patch from bug #321760 comment #21) altogether.

I however in the meantime also tried creating an indirect context on the gma945 and that "just worked" - it's probably fglrx specific (and definitly different from bug #321760)


(In reply to comment #21)
> Yes, the patch resolved the problem here :-)

Oh, great.
I assume that also means that afterwards compositing works as expected?

Next step is to find the culprit call - see attached diff =)
Comment 23 Hrvoje Senjan 2013-08-31 13:37:52 UTC
Created attachment 82056 [details]
KWin output with last patch

(In reply to comment #22)
> Created attachment 82047 [details]
> Print gl errors after each major init step and some suspicious calls
With the patch, it's at GL init

> I assume that also means that afterwards compositing works as expected?
Yes, indirect rendering worked with previous, and also with the last patch ;-)
Comment 24 Thomas Lübking 2013-08-31 14:27:26 UTC
Created attachment 82058 [details]
print errors in initGL

mehh
ok, new attachement raises error detection resolution to initGL ...
Comment 25 Thomas Lübking 2013-08-31 15:57:16 UTC
*** Bug 324272 has been marked as a duplicate of this bug. ***
Comment 26 Hrvoje Senjan 2013-08-31 17:04:21 UTC
(In reply to comment #24)
> ok, new attachement raises error detection resolution to initGL ...


kwin(1044) KWin::checkGLError: GL error ( initGL start ):  "GL_INVALID_ENUM" 

So, it missdetects openGL version?
Comment 27 Thomas Lübking 2013-08-31 17:20:55 UTC
no - in platform detection (or setting the sync preference)
the error is already there when entering the init.
Comment 28 Thomas Lübking 2013-08-31 19:03:08 UTC
Created attachment 82070 [details]
So let's look into glplatform

So let's look into glplatform ...
Comment 29 Hrvoje Senjan 2013-08-31 21:38:44 UTC
Aha :-)

kwin(991) KWin::Compositor::slotCompositingOptionsInitialized: Initializing OpenGL compositing
...
kwin(991) KWin::checkGLError: GL error ( glsl ):  "GL_INVALID_ENUM" 
...
OpenGL version:                         2.1
GLSL version:                           0.0
....
kwin(991) KWin::GlxBackend::init: Direct rendering: false
kwin(991) KWin::SceneOpenGL1::SceneOpenGL1: OpenGL 1 compositing successfully initialized
kwin(991) KWin::currentRefreshRate: Vertical Refresh rate  60 Hz
Comment 30 Thomas Lübking 2013-08-31 22:01:52 UTC
Created attachment 82072 [details]
depend glsl support on direct rendering

Well, in a twisted way that actually makes sense - glsl is not supported on direct rendering, just that "GL_SHADING_LANGUAGE_VERSION" is not an invalid enum on OpenGL >= 2.0 (and from your glxinfo diff, the relevant extensions should not be there either)

Does the attached patch work?
Comment 31 Hrvoje Senjan 2013-08-31 22:18:36 UTC
(In reply to comment #30)
> Does the attached patch work?

Yes, works as expected :-)
Comment 32 Thomas Lübking 2013-09-08 22:03:43 UTC
Git commit 41f3aa6c2f9587cf22ed09813ea7822473bec44c by Thomas Lübking.
Committed on 31/08/2013 at 21:50.
Pushed by luebking into branch 'KDE/4.11'.

glsl is not supported on indirect contexts

and fglrx yells an invalid_enum error when being asked
for the version
FIXED-IN: 4.11.2
REVIEW: 112419

M  +2    -1    kwin/libkwineffects/kwinglplatform.cpp

http://commits.kde.org/kde-workspace/41f3aa6c2f9587cf22ed09813ea7822473bec44c